std::_List_base< _Tp, _Alloc > Class Template Reference

`#include <stl_list.h>`

Inheritance diagram for std::_List_base< _Tp, _Alloc >:
[legend]

## Public Types

typedef _Alloc | allocator_type

## Public Member Functions

| _List_base (_List_base &&)=default
| _List_base (_List_base &&__x, _Node_alloc_type &&__a)
| _List_base (_Node_alloc_type &&__a)
| _List_base (_Node_alloc_type &&__a, _List_base &&__x)
| _List_base (const _Node_alloc_type &__a) noexcept
void | _M_clear () noexcept
const _Node_alloc_type & | _M_get_Node_allocator () const noexcept
_Node_alloc_type & | _M_get_Node_allocator () noexcept
void | _M_init () noexcept
void | _M_move_nodes (_List_base &&__x)

## Protected Types

typedef __gnu_cxx::__alloc_traits< _Node_alloc_type > | _Node_alloc_traits
typedef _Tp_alloc_traits::template rebind< _List_node< _Tp > >::other | _Node_alloc_type
typedef __gnu_cxx::__alloc_traits< _Tp_alloc_type > | _Tp_alloc_traits
typedef __gnu_cxx::__alloc_traits< _Alloc >::template rebind< _Tp >::other | _Tp_alloc_type

## Protected Member Functions

void | _M_dec_size (size_t __n)
size_t | _M_distance (const __detail::_List_node_base *__first, const __detail::_List_node_base *__last) const
_Node_alloc_traits::pointer | _M_get_node ()
size_t | _M_get_size () const
void | _M_inc_size (size_t __n)
size_t | _M_node_count () const
void | _M_put_node (typename _Node_alloc_traits::pointer __p) noexcept
void | _M_set_size (size_t __n)

## Static Protected Member Functions

static size_t | _S_distance (const __detail::_List_node_base *__first, const __detail::_List_node_base *__last)

## Protected Attributes

_List_impl | _M_impl

## Detailed Description

template<typename _Tp, typename _Alloc>
class std::_List_base< _Tp, _Alloc >

See bits/stl_deque.h's _Deque_base for an explanation.

Definition at line 426 of file stl_list.h.

## Member Typedef Documentation

## _Node_alloc_traits

template<typename _Tp, typename _Alloc>

typedef __gnu_cxx::__alloc_traits<_Node_alloc_type> std::_List_base< _Tp, _Alloc >::_Node_alloc_traits

protected

Definition at line 434 of file stl_list.h.

## _Node_alloc_type

template<typename _Tp, typename _Alloc>

typedef _Tp_alloc_traits::template rebind<_List_node<_Tp>>::other std::_List_base< _Tp, _Alloc >::_Node_alloc_type

protected

Definition at line 433 of file stl_list.h.

## _Tp_alloc_traits

template<typename _Tp, typename _Alloc>

typedef __gnu_cxx::__alloc_traits<_Tp_alloc_type> std::_List_base< _Tp, _Alloc >::_Tp_alloc_traits

protected

Definition at line 431 of file stl_list.h.

## _Tp_alloc_type

template<typename _Tp, typename _Alloc>

typedef __gnu_cxx::__alloc_traits<_Alloc>::template rebind<_Tp>::other std::_List_base< _Tp, _Alloc >::_Tp_alloc_type

protected

Definition at line 430 of file stl_list.h.

## allocator_type

template<typename _Tp, typename _Alloc>

typedef _Alloc std::_List_base< _Tp, _Alloc >::allocator_type

Definition at line 526 of file stl_list.h.

## Constructor & Destructor Documentation

## _List_base() [1/4]

template<typename _Tp, typename _Alloc>

std::_List_base< _Tp, _Alloc >::_List_base | ( | const _Node_alloc_type & | __a | ) |

inline noexcept

Definition at line 542 of file stl_list.h.

## _List_base() [2/4]

template<typename _Tp, typename _Alloc>

std::_List_base< _Tp, _Alloc >::_List_base | ( | _List_base< _Tp, _Alloc > && | __x,
|  | _Node_alloc_type && | __a )

inline

Definition at line 550 of file stl_list.h.

## _List_base() [3/4]

template<typename _Tp, typename _Alloc>

std::_List_base< _Tp, _Alloc >::_List_base | ( | _Node_alloc_type && | __a,
|  | _List_base< _Tp, _Alloc > && | __x )

inline

Definition at line 560 of file stl_list.h.

## _List_base() [4/4]

template<typename _Tp, typename _Alloc>

std::_List_base< _Tp, _Alloc >::_List_base | ( | _Node_alloc_type && | __a | ) |

inline

Definition at line 565 of file stl_list.h.

## ~_List_base()

template<typename _Tp, typename _Alloc>

std::_List_base< _Tp, _Alloc >::~_List_base | ( |  | ) |

inline noexcept

Definition at line 575 of file stl_list.h.

## Member Function Documentation

## _M_clear()

template<typename _Tp, typename _Alloc>

void std::_List_base< _Tp, _Alloc >::_M_clear | ( |  | ) |

noexcept

Definition at line 66 of file list.tcc.

## _M_dec_size()

template<typename _Tp, typename _Alloc>

void std::_List_base< _Tp, _Alloc >::_M_dec_size | ( | size_t | __n | ) |

inline protected

Definition at line 487 of file stl_list.h.

## _M_distance()

template<typename _Tp, typename _Alloc>

size_t std::_List_base< _Tp, _Alloc >::_M_distance | ( | const __detail::_List_node_base * | __first,
|  | const __detail::_List_node_base * | __last ) const

inline protected

Definition at line 491 of file stl_list.h.

## _M_get_node()

template<typename _Tp, typename _Alloc>

_Node_alloc_traits::pointer std::_List_base< _Tp, _Alloc >::_M_get_node | ( |  | ) |

inline protected

Definition at line 518 of file stl_list.h.

## _M_get_Node_allocator() [1/2]

template<typename _Tp, typename _Alloc>

const _Node_alloc_type & std::_List_base< _Tp, _Alloc >::_M_get_Node_allocator | ( |  | ) | const

inline noexcept

Definition at line 533 of file stl_list.h.

## _M_get_Node_allocator() [2/2]

template<typename _Tp, typename _Alloc>

_Node_alloc_type & std::_List_base< _Tp, _Alloc >::_M_get_Node_allocator | ( |  | ) |

inline noexcept

Definition at line 529 of file stl_list.h.

## _M_get_size()

template<typename _Tp, typename _Alloc>

size_t std::_List_base< _Tp, _Alloc >::_M_get_size | ( |  | ) | const

inline protected

Definition at line 481 of file stl_list.h.

## _M_inc_size()

template<typename _Tp, typename _Alloc>

void std::_List_base< _Tp, _Alloc >::_M_inc_size | ( | size_t | __n | ) |

inline protected

Definition at line 485 of file stl_list.h.

## _M_init()

template<typename _Tp, typename _Alloc>

void std::_List_base< _Tp, _Alloc >::_M_init | ( |  | ) |

inline noexcept

Definition at line 582 of file stl_list.h.

## _M_move_nodes()

template<typename _Tp, typename _Alloc>

void std::_List_base< _Tp, _Alloc >::_M_move_nodes | ( | _List_base< _Tp, _Alloc > && | __x | ) |

inline

Definition at line 570 of file stl_list.h.

## _M_node_count()

template<typename _Tp, typename _Alloc>

size_t std::_List_base< _Tp, _Alloc >::_M_node_count | ( |  | ) | const

inline protected

Definition at line 496 of file stl_list.h.

## _M_put_node()

template<typename _Tp, typename _Alloc>

void std::_List_base< _Tp, _Alloc >::_M_put_node | ( | typename _Node_alloc_traits::pointer | __p | ) |

inline protected noexcept

Definition at line 522 of file stl_list.h.

## _M_set_size()

template<typename _Tp, typename _Alloc>

void std::_List_base< _Tp, _Alloc >::_M_set_size | ( | size_t | __n | ) |

inline protected

Definition at line 483 of file stl_list.h.

## _S_distance()

template<typename _Tp, typename _Alloc>

size_t std::_List_base< _Tp, _Alloc >::_S_distance | ( | const __detail::_List_node_base * | __first,
|  | const __detail::_List_node_base * | __last )

inline static protected

Definition at line 438 of file stl_list.h.

## Member Data Documentation

## _M_impl

template<typename _Tp, typename _Alloc>

_List_impl std::_List_base< _Tp, _Alloc >::_M_impl

protected

Definition at line 478 of file stl_list.h.

The documentation for this class was generated from the following files:

- stl_list.h
- list.tcc